module Tools (..) where

import Random exposing (Generator, Seed)
import Graphics.Collage exposing (solid, LineStyle)
import Color exposing (Color)


product : List a -> List b -> List ( a, b )
product l r =
  List.foldr (\x acc -> List.map ((,) x) r ++ acc) [] l


countList : (a -> Bool) -> List a -> Int
countList f =
  List.foldr
    (\a b ->
      b
        + if f a then
            1
          else
            0
    )
    0


insert : Int -> a -> List a -> List a
insert pos a l =
  case ( List.head l, List.tail l ) of
    ( Nothing, _ ) ->
      [ a ]

    ( _, Nothing ) ->
      [ a ]

    ( Just h, Just t ) ->
      if pos <= 0 then
        a :: l
      else
        h :: insert (pos - 1) a t


insertSlice : Int -> List a -> List a -> List a
insertSlice pos s l =
  case ( List.head l, List.tail l ) of
    ( Nothing, _ ) ->
      s

    ( _, Nothing ) ->
      s

    ( Just h, Just t ) ->
      if pos <= 0 then
        s ++ l
      else
        h :: insertSlice (pos - 1) s t


constGenerator : a -> Generator a
constGenerator a =
  Random.map (always a) Random.bool


generateList : List (Generator a) -> Generator (List a)
generateList =
  List.foldr (Random.map2 (::)) (constGenerator [])


solidWidth : Color -> Float -> LineStyle
solidWidth c w =
  let
    s =
      solid c
  in
    { s | width = w }


isJust : Maybe a -> Bool
isJust a =
  case a of
    Nothing ->
      False

    Just _ ->
      True
